/* ϴϸ(hanemacs) Emacs 󿡼 ѱ   ֵ
    α׷Դϴ.
   Copyright (C) 1994, 1995 ϴϸư(fpf545@dosa1.snu.ac.kr).

   Emacs ҽ ڵ忡 ѱ ó   κ KEMACS 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.

HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HanEmacs; If not, write to the Free Software 
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* ѱ 2 丶Ÿ : 
   "ǻͼ ѱ(ô)" Ǵ ѱ 2 丶Ÿ
   ⺻ Ͽ, н ȯ濡 µ Ͽϴ. */

#include "config.h"
#include "hangul.h"

#define TRUE  1
#define FALSE 0

enum HAN_STATUS {               /*  ¸  */
  HS_Start,
  HS_Chosung,
  HS_Joongsung, HS_dJoongsung,
  HS_Jongsung,  HS_dJongsung,
  HS_End1,      HS_End2
};

enum HAN_CHKIND { CONSONANT,  VOWEL };

static int CharCode;
static int OldKey;
static int KeyCode;

/*
**  ̷ ˻Ѵ.
*/
static int JoongsungPair(void)
{
  static char dJoongTable[7][3] = {
    0xad, 0xa3, 0xae,               /* , ,  */
    0xad, 0xa4, 0xaf,               /* , ,  */
    0xad, 0xbd, 0xb2,               /* , ,  */
    0xb4, 0xa7, 0xb5,               /* , ,  */
    0xb4, 0xaa, 0xb6,               /* , ,  */
    0xb4, 0xbd, 0xb7,               /* , ,  */
    0xbb, 0xbd, 0xbc                /* , ,  */
  };
  int i;
  
  for (i = 0; i < 7; i++) {
    if ( (((int) dJoongTable[i][0]) & 0x000000ff) == OldKey 
	 && (((int) dJoongTable[i][1]) & 0x000000ff) == KeyCode)
      return (KeyCode = (((int) dJoongTable[i][2]) & 0x000000ff));
  }
  return 0;
}

/*
** ħ ̷ ˻Ѵ.
*/
static int JongsungPair(void)
{
  static char dJongTable[11][3] = {
    0x82, 0x8b, 0xc4,               /* ⿪, ÿ */
    0x84, 0x8e, 0xc6,               /* ,  */
    0x84, 0x94, 0xc7,               /* ,  */
    0x87, 0x82, 0xca,               /* , ⿪ */
    0x87, 0x88, 0xcb,               /* ,  */
    0x87, 0x89, 0xcc,               /* ,  */
    0x87, 0x8b, 0xcd,               /* , ÿ */
    0x87, 0x92, 0xce,               /* , Ƽ */
    0x87, 0x93, 0xcf,               /* ,  */
    0x87, 0x94, 0xd0,               /* ,  */
    0x89, 0x8b, 0xd4,               /* , ÿ */
  };
  int i;
  
  for (i = 0; i < 11; i++) {
    if ( (((int) dJongTable[i][0]) & 0x000000ff) == OldKey 
	 && (((int) dJongTable[i][1]) & 0x000000ff) == KeyCode)
      return (KeyCode = (((int) dJongTable[i][2]) & 0x000000ff));
  }
  return 0;
}

/********************************************************************
        ι 丶Ÿ
********************************************************************/

int HanAutomata2(HAN_AUTO_STATUS *stack_frame, int key)
/*--------------------------------------------------------------------
  : key = Էµ Ű ڵ
ȯ:     0̿,  ̸ 1
                ϼ  ڵ Է   
                  ִ.
--------------------------------------------------------------------*/
{
  HAN_AUTO_STATUS *sf = stack_frame;
  int ChKind, CanBeJongsung = FALSE;
  static char Cho2Jong[] = {      /* ʼ ڵ忡 ϴ  ڵ */
    0xc2,   /*  ⿪                                */
    0xc3,   /*  ֱ⿪                              */
    0xc5,   /*                                  */
    0xc8,   /*                                  */
    0x00,   /*  ֵ (ش )  */
    0xc9,   /*                                  */
    0xd1,   /*                                  */
    0xd3,   /*                                  */
    0x00,   /*   (ش )  */
    0xd5,   /*  ÿ                                */
    0xd6,   /*  ֽÿ                              */
    0xd7,   /*                                  */
    0xd8,   /*                                  */
    0x00,   /*   (ش )  */
    0xd9,   /*  ġ                                */
    0xda,   /*  Ű                                */
    0xdb,   /*  Ƽ                                */
    0xdc,   /*                                  */
    0xdd    /*                                  */
  };

  if ((key & 0x60) == 0x20) {
    ChKind = VOWEL;
  } else {
    ChKind = CONSONANT;
    if (!(key == 0x86 || key == 0x8A || key == 0x8F))
      CanBeJongsung = TRUE;
  }

  if (sf->CurHanState) {
    CharCode = sf->InpStack[(sf->InpSP)-1].charcode;
    OldKey   = sf->InpStack[(sf->InpSP)-1].key;
  } else {
    CharCode = 0x8441;
    OldKey   = 0;
  }

  KeyCode = key;

  switch (sf->CurHanState) {
  case HS_Start:
    if (ChKind == CONSONANT)
      sf->CurHanState = HS_Chosung;
    else
      sf->CurHanState = HS_Joongsung;
    break;
  case HS_Chosung:
    if (ChKind == VOWEL)
      sf->CurHanState = HS_Joongsung;
    else
      sf->CurHanState = HS_End1;
    break;
  case HS_Joongsung:
    if (CanBeJongsung)
      sf->CurHanState = HS_Jongsung;
    else if (JoongsungPair())
      sf->CurHanState = HS_dJoongsung;
    else
      sf->CurHanState = HS_End1;
    break;
  case HS_dJoongsung:
    if (CanBeJongsung)
      sf->CurHanState = HS_Jongsung;
    else
      sf->CurHanState = HS_End1;
    break;
  case HS_Jongsung:
    if (ChKind == CONSONANT && JongsungPair())
      sf->CurHanState = HS_dJongsung;
    else if (ChKind == VOWEL)
      sf->CurHanState = HS_End2;
    else
      sf->CurHanState = HS_End1;
    break;
  case HS_dJongsung:
    if (ChKind == VOWEL)
      sf->CurHanState = HS_End2;
    else
      sf->CurHanState = HS_End1;
    break;
  }

  switch (sf->CurHanState) {
  case HS_Chosung:
    CharCode = (CharCode & 0x83FF) | ((KeyCode - 0x80) << 10);
    break;
  case HS_Joongsung:
  case HS_dJoongsung:
    CharCode = (CharCode & 0xFC1F) | ((KeyCode - 0xA0) << 5);
    break;
  case HS_Jongsung:
    KeyCode = (((int) Cho2Jong[KeyCode - 0x82]) & 0x000000ff);
  case HS_dJongsung:
    CharCode = (CharCode & 0xFFE0) | (KeyCode - 0xC0);
    break;
  case HS_End1:
    sf->OutStack[(sf->OutSP)++] = key;
    return TRUE;
  case HS_End2:
    sf->OutStack[(sf->OutSP)++] = key;
    sf->OutStack[(sf->OutSP)++] = OldKey;
    (sf->InpSP)--;
    return TRUE;
  }

  sf->InpStack[sf->InpSP].curhanst = sf->CurHanState;
  sf->InpStack[sf->InpSP].charcode = CharCode;
  sf->InpStack[(sf->InpSP)++].key    = key;

  return FALSE;
}
