/* ϴϸ(hanemacs) Emacs 󿡼 ѱ   ֵ
    α׷Դϴ.
   Copyright (C) 1994, 1995 ϴϸư(fpf545@dosa1.snu.ac.kr).

   Emacs ҽ ڵ忡 ѱ ó   κ KEMACS 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.

HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HanEmacs; If not, write to the Free Software 
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* ѱ 3 丶Ÿ : 
   "ǻͼ ѱ(ô)" Ǵ ѱ 3 丶Ÿ
   ⺻ Ͽ, н ȯ濡 µ Ͽϴ. */

#include "config.h"
#include "hangul.h"

#define TRUE  1
#define FALSE 0

enum HAN_STATUS {               /*  ¸  */
  HS_Start,
  HS_Chosung,   HS_dChosung,
  HS_Joongsung, HS_dJoongsung,
  HS_Jongsung,  HS_dJongsung,
  HS_End
};

enum HAN_CHKIND {               /* Էµ ڸ  */
  CHOSUNG   = 0x00,
  JOONGSUNG = 0x20,
  JONGSUNG  = 0x40
};

static int CharCode;
static int OldKey;
static int KeyCode;

/*
** ʼ ڵ尡  ̷ ˻Ѵ.
*/
static int ChosungPair(void)
{
  static char dChoTable[][3] = {
    0x82, 0x82, 0x83,               /* ⿪, ⿪, ֱ⿪ */
    0x85, 0x85, 0x86,               /* , , ֵ */
    0x89, 0x89, 0x8a,               /* , , ֺ */
    0x8b, 0x8b, 0x8c,               /* ÿ, ÿ, ֽÿ */
    0x8e, 0x8e, 0x8f                /* , ,  */
  };
  int i;
  
  for (i = 0; i < 5; i++) {
    if ( (((int) dChoTable[i][0]) & 0x000000ff) == OldKey 
	 && (((int) dChoTable[i][1]) & 0x000000ff) == KeyCode)
      return (KeyCode = (((int) dChoTable[i][2]) & 0x000000ff));
  }
  return 0;
}

/*
**  ̷ ˻Ѵ.
*/
static int JoongsungPair(void)
{
  static char dJoongTable[][3] = {
    0xad, 0xa3, 0xae,               /* , ,  */
    0xad, 0xa4, 0xaf,               /* , ,  */
    0xad, 0xbd, 0xb2,               /* , ,  */
    0xb4, 0xa7, 0xb5,               /* , ,  */
    0xb4, 0xaa, 0xb6,               /* , ,  */
    0xb4, 0xbd, 0xb7,               /* , ,  */
    0xbb, 0xbd, 0xbc                /* , ,  */
  };
  int i;
  
  for (i = 0; i < 7; i++) {
    if ((((int) dJoongTable[i][0]) & 0x000000ff) == OldKey
	&& (((int) dJoongTable[i][1]) & 0x000000ff) == KeyCode)
      return (KeyCode = (((int) dJoongTable[i][2]) & 0x000000ff));
  }
  return 0;
}

/*
** ħ ̷ ˻Ѵ.
*/
static int JongsungPair(void)
{
  static char dJongTable[][3] = {
    0xc2, 0xc2, 0xc3,               /* ⿪, ⿪ */
    0xc2, 0xd5, 0xc4,               /* ⿪, ÿ */
    0xc5, 0xd8, 0xc6,               /* ,  */
    0xc5, 0xdd, 0xc7,               /* ,  */
    0xc9, 0xc2, 0xca,               /* , ⿪ */
    0xc9, 0xd1, 0xcb,               /* ,  */
    0xc9, 0xd3, 0xcc,               /* ,  */
    0xc9, 0xd5, 0xcd,               /* , ÿ */
    0xc9, 0xdb, 0xce,               /* , Ƽ */
    0xc9, 0xdc, 0xcf,               /* ,  */
    0xc9, 0xdd, 0xd0,               /* ,  */
    0xd3, 0xd5, 0xd4,               /* , ÿ */
    0xd5, 0xd5, 0xd6                /* ÿ, ÿ */
  };
  int i;
  
  for (i = 0; i < 13; i++) {
    if ((((int) dJongTable[i][0]) & 0x000000ff) == OldKey 
	&& (((int) dJongTable[i][1]) & 0x000000ff) == KeyCode)
      return (KeyCode = (((int) dJongTable[i][2]) & 0x000000ff));
  }
  return 0;
}

/********************************************************************
         丶Ÿ
********************************************************************/

int HanAutomata3(HAN_AUTO_STATUS *stack_frame, int key)
/*--------------------------------------------------------------------
  : key = Էµ Ű ڵ
ȯ:     0̿,  ̸ 1
                ϼ  ڵ Է   
                  ִ.
--------------------------------------------------------------------*/
{
  HAN_AUTO_STATUS *sf = stack_frame;
  int ChKind = key & 0x60;
  
  if (sf->CurHanState) {
    CharCode = sf->InpStack[(sf->InpSP)-1].charcode;
    OldKey   = sf->InpStack[(sf->InpSP)-1].key;
  } else {
    CharCode = 0x8441;
    OldKey   = 0;
  }

  KeyCode = key;

  switch (sf->CurHanState) {
  case HS_Start:
    switch (ChKind) {
    case CHOSUNG:
      sf->CurHanState = HS_Chosung;
      break;
    case JOONGSUNG:
      sf->CurHanState = HS_Joongsung;
      break;
    case JONGSUNG:
      sf->CurHanState = HS_Jongsung;
      break;
    }
    break;
  case HS_Chosung:
    switch (ChKind) {
    case CHOSUNG:
      if (ChosungPair())
	sf->CurHanState = HS_dChosung;
      else
	sf->CurHanState = HS_End;
      break;
    case JOONGSUNG:
      sf->CurHanState = HS_Joongsung;
      break;
    case JONGSUNG:
      sf->CurHanState = HS_Jongsung;
      break;
    }
    break;
  case HS_dChosung:
    switch (ChKind) {
    case CHOSUNG:
      sf->CurHanState = HS_End;
      break;
    case JOONGSUNG:
      sf->CurHanState = HS_Joongsung;
      break;
    case JONGSUNG:
      sf->CurHanState = HS_Jongsung;
      break;
    }
    break;
  case HS_Joongsung:
    switch (ChKind) {
    case CHOSUNG:
      sf->CurHanState = HS_End;
      break;
    case JOONGSUNG:
      if (JoongsungPair())
	sf->CurHanState = HS_dJoongsung;
      else
	sf->CurHanState = HS_End;
      break;
    case JONGSUNG:
      sf->CurHanState = HS_Jongsung;
      break;
    }
    break;
  case HS_dJoongsung:
    switch (ChKind) {
    case CHOSUNG:
    case JOONGSUNG:
      sf->CurHanState = HS_End;
      break;
    case JONGSUNG:
      sf->CurHanState = HS_Jongsung;
      break;
    }
    break;
  case HS_Jongsung:
    switch (ChKind) {
    case CHOSUNG:
    case JOONGSUNG:
      sf->CurHanState = HS_End;
      break;
    case JONGSUNG:
      if (JongsungPair())
	sf->CurHanState = HS_dJongsung;
      else
	sf->CurHanState = HS_End;
      break;
    }
    break;
  case HS_dJongsung:
    sf->CurHanState = HS_End;
    break;
  }

  switch (sf->CurHanState) {
  case HS_Chosung:
  case HS_dChosung:
    CharCode = (CharCode & 0x83FF) | ((KeyCode - 0x80) << 10);
    break;
  case HS_Joongsung:
  case HS_dJoongsung:
    CharCode = (CharCode & 0xFC1F) | ((KeyCode - 0xA0) << 5);
    break;
  case HS_Jongsung:
  case HS_dJongsung:
    CharCode = (CharCode & 0xFFE0) | (KeyCode - 0xC0);
    break;
  case HS_End:
    sf->OutStack[(sf->OutSP)++] = key;
    return TRUE;
  }

  sf->InpStack[sf->InpSP].curhanst = sf->CurHanState;
  sf->InpStack[sf->InpSP].charcode = CharCode;
  sf->InpStack[(sf->InpSP)++].key    = key;

  return FALSE;
}
